/************************************************************************************
*                                                                                   *
*   Copyright (c) 2014 Axel Menzel <info@axelmenzel.de>                             *
*                                                                                   *
*   This file is part of RTTR (Run Time Type Reflection)                            *
*   License: MIT License                                                            *
*                                                                                   *
*   Permission is hereby granted, free of charge, to any person obtaining           *
*   a copy of this software and associated documentation files (the "Software"),    *
*   to deal in the Software without restriction, including without limitation       *
*   the rights to use, copy, modify, merge, publish, distribute, sublicense,        *
*   and/or sell copies of the Software, and to permit persons to whom the           *
*   Software is furnished to do so, subject to the following conditions:            *
*                                                                                   *
*   The above copyright notice and this permission notice shall be included in      *
*   all copies or substantial portions of the Software.                             *
*                                                                                   *
*   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR      *
*   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,        *
*   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE     *
*   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER          *
*   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,   *
*   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE   *
*   SOFTWARE.                                                                       *
*                                                                                   *
*************************************************************************************/

#ifndef __RTTR_STANDARD_TYPES_H__
#define __RTTR_STANDARD_TYPES_H__

#include "rttr/type.h"
#include "rttr/rttr_enable.h"
#include "rttr/detail/array_container.h"

#include <string>
#include <vector>

RTTR_DECLARE_STANDARD_TYPE_VARIANTS(void)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(bool)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(signed char)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(unsigned char)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(char)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(wchar_t)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(short int)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(unsigned short int)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(int)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(unsigned int)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(long int)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(unsigned long int)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(long long int)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(unsigned long long int)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(float)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(double)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(long double)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(std::string)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(std::vector<int>)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(std::vector<float>)
RTTR_DECLARE_STANDARD_TYPE_VARIANTS(std::vector<double>)

RTTR_DECLARE_TYPE(char[1 ])
RTTR_DECLARE_TYPE(char[2 ])
RTTR_DECLARE_TYPE(char[3 ])
RTTR_DECLARE_TYPE(char[4 ])
RTTR_DECLARE_TYPE(char[5 ])
RTTR_DECLARE_TYPE(char[6 ])
RTTR_DECLARE_TYPE(char[7 ])
RTTR_DECLARE_TYPE(char[8 ])
RTTR_DECLARE_TYPE(char[9 ])
RTTR_DECLARE_TYPE(char[10])
RTTR_DECLARE_TYPE(char[11])
RTTR_DECLARE_TYPE(char[12])
RTTR_DECLARE_TYPE(char[13])
RTTR_DECLARE_TYPE(char[14])
RTTR_DECLARE_TYPE(char[15])
RTTR_DECLARE_TYPE(char[16])
RTTR_DECLARE_TYPE(char[17])
RTTR_DECLARE_TYPE(char[18])
RTTR_DECLARE_TYPE(char[19])
RTTR_DECLARE_TYPE(char[20])
RTTR_DECLARE_TYPE(char[21])
RTTR_DECLARE_TYPE(char[22])
RTTR_DECLARE_TYPE(char[23])
RTTR_DECLARE_TYPE(char[24])
RTTR_DECLARE_TYPE(char[25])
RTTR_DECLARE_TYPE(char[26])
RTTR_DECLARE_TYPE(char[27])
RTTR_DECLARE_TYPE(char[28])
RTTR_DECLARE_TYPE(char[29])
RTTR_DECLARE_TYPE(char[30])
RTTR_DECLARE_TYPE(char[31])
RTTR_DECLARE_TYPE(char[32])
RTTR_DECLARE_TYPE(char[33])
RTTR_DECLARE_TYPE(char[34])
RTTR_DECLARE_TYPE(char[35])
RTTR_DECLARE_TYPE(char[36])
RTTR_DECLARE_TYPE(char[37])
RTTR_DECLARE_TYPE(char[38])
RTTR_DECLARE_TYPE(char[39])
RTTR_DECLARE_TYPE(char[40])
RTTR_DECLARE_TYPE(char[41])
RTTR_DECLARE_TYPE(char[42])
RTTR_DECLARE_TYPE(char[43])
RTTR_DECLARE_TYPE(char[44])
RTTR_DECLARE_TYPE(char[45])
RTTR_DECLARE_TYPE(char[46])
RTTR_DECLARE_TYPE(char[47])
RTTR_DECLARE_TYPE(char[48])
RTTR_DECLARE_TYPE(char[49])
RTTR_DECLARE_TYPE(char[50])
RTTR_DECLARE_TYPE(char[51])
RTTR_DECLARE_TYPE(char[52])
RTTR_DECLARE_TYPE(char[53])
RTTR_DECLARE_TYPE(char[54])
RTTR_DECLARE_TYPE(char[55])
RTTR_DECLARE_TYPE(char[56])
RTTR_DECLARE_TYPE(char[57])
RTTR_DECLARE_TYPE(char[58])
RTTR_DECLARE_TYPE(char[59])
RTTR_DECLARE_TYPE(char[60])

#endif // __RTTR_STANDARD_TYPES_H__